#import <Foundation/Foundation.h>
#ifndef GNUSTEP
#import <objc/objc-runtime.h>
#else
#include <GNUstepBase/objc-gnu2next.h>
#endif
#include <stdio.h>

int main()
{
  NSAutoreleasePool *pool = [NSAutoreleasePool new];
  Class *classes;
  Class aClass;
  int numClasses = 0;
  int newNumClasses;
  int i,j = 0;
  NSMutableDictionary *dict, *classDict;
  NSMutableArray *classMethods,*instanceMethods;
  void *class_iterator = 0;
  classes = (Class*)malloc(1);
#ifndef GNUSTEP
  newNumClasses = objc_getClassList(NULL,0);
  do
    {
      numClasses = newNumClasses;
      classes = (Class*)realloc(classes,sizeof(Class) * numClasses);
      newNumClasses = objc_getClassList(classes,numClasses);
    }
  while(numClasses < newNumClasses);

  dict = [[NSMutableDictionary alloc] initWithCapacity:numClasses];
  for (i = 0; i < numClasses; i++)
#else
  dict = [[NSMutableDictionary alloc] init];
  while ((aClass = objc_next_class(&class_iterator)))
#endif
    {
	void *method_iterator = 0;
	struct objc_method_list *mlist;
	instanceMethods = [[NSMutableArray alloc] init];
#ifndef GNUSTEP
	aClass = classes[i];
#endif
	while ((mlist = class_nextMethodList(aClass, &method_iterator)))
	  {
	     for (j = 0; j < mlist->method_count; j++)
               {
                 char *mthd = (char *)sel_getName(mlist->method_list[j].method_name);
		 [instanceMethods addObject: [NSString stringWithCString: mthd]];
	       } 
	  }
	method_iterator = 0;
	classMethods = [[NSMutableArray alloc] init];
	#ifndef GNUSTEP
	while ((mlist = class_nextMethodList(aClass->isa, &method_iterator)))
	#else
	while ((mlist = class_nextMethodList(aClass->class_pointer, &method_iterator)))
	#endif
          {
             for (j = 0; j < mlist->method_count; j++)
               {
		 char *mthd = (char *) mlist->method_list[j].method_name;
                 [classMethods addObject: [NSString stringWithCString: mthd]];
               }
          }

        classDict = [NSDictionary dictionaryWithObjectsAndKeys: instanceMethods, @"InstanceMethods", classMethods, @"ClassMethods",nil];
        //[instanceMethods release];
        //[classMethods release];
        
        [dict setObject:classDict 
                 forKey:[NSString stringWithCString:aClass->name]];
        [classDict release];
    }
  #ifndef GNUSTEP
  [dict writeToFile:@"apple.plist" atomically:YES];
  #else
  [dict writeToFile:@"gnustep.plist" atomically:YES];
  #endif
}
